This documentation is automatically generated by online-judge-tools/verification-helper
View the Project on GitHub maspypy/library
#include "linalg/adjugate_matrix.hpp"
#include "linalg/frobenius.hpp" #include "mod/modint.hpp" #include "linalg/characteristic_poly.hpp" #include "linalg/frobenius.hpp" template <typename mint> vvc<mint> adjugate_matrix(vvc<mint> A) { int N = len(A); Frobenius_Form<mint> X(A); auto F = X.characteristic_poly(); if (N % 2 == 0) { for (auto& x: F) x = -x; } F.erase(F.begin()); return X.poly_eval(F); }
#line 1 "linalg/adjugate_matrix.hpp" #line 2 "random/base.hpp" u64 RNG_64() { static u64 x_ = u64(chrono::duration_cast<chrono::nanoseconds>(chrono::high_resolution_clock::now().time_since_epoch()).count()) * 10150724397891781847ULL; x_ ^= x_ << 7; return x_ ^= x_ >> 9; } u64 RNG(u64 lim) { return RNG_64() % lim; } ll RNG(ll l, ll r) { return l + RNG_64() % (r - l); } #line 2 "linalg/matrix_inv.hpp" // (det, invA) をかえす template <typename T> pair<T, vc<vc<T>>> matrix_inv(vc<vc<T>> A) { T det = 1; int N = len(A); vv(T, B, N, N); FOR(n, N) B[n][n] = 1; FOR(i, N) { FOR(k, i, N) if (A[k][i] != 0) { if (k != i) { swap(A[i], A[k]), swap(B[i], B[k]); det = -det; } break; } if (A[i][i] == 0) return {T(0), {}}; T c = T(1) / A[i][i]; det *= A[i][i]; FOR(j, i, N) A[i][j] *= c; FOR(j, N) B[i][j] *= c; FOR(k, N) if (i != k) { T c = A[k][i]; FOR(j, i, N) A[k][j] -= A[i][j] * c; FOR(j, N) B[k][j] -= B[i][j] * c; } } return {det, B}; } #line 2 "mod/modint_common.hpp" struct has_mod_impl { template <class T> static auto check(T &&x) -> decltype(x.get_mod(), std::true_type{}); template <class T> static auto check(...) -> std::false_type; }; template <class T> class has_mod : public decltype(has_mod_impl::check<T>(std::declval<T>())) {}; template <typename mint> mint inv(int n) { static const int mod = mint::get_mod(); static vector<mint> dat = {0, 1}; assert(0 <= n); if (n >= mod) n %= mod; while (len(dat) <= n) { int k = len(dat); int q = (mod + k - 1) / k; dat.eb(dat[k * q - mod] * mint::raw(q)); } return dat[n]; } template <typename mint> mint fact(int n) { static const int mod = mint::get_mod(); assert(0 <= n && n < mod); static vector<mint> dat = {1, 1}; while (len(dat) <= n) dat.eb(dat[len(dat) - 1] * mint::raw(len(dat))); return dat[n]; } template <typename mint> mint fact_inv(int n) { static vector<mint> dat = {1, 1}; if (n < 0) return mint(0); while (len(dat) <= n) dat.eb(dat[len(dat) - 1] * inv<mint>(len(dat))); return dat[n]; } template <class mint, class... Ts> mint fact_invs(Ts... xs) { return (mint(1) * ... * fact_inv<mint>(xs)); } template <typename mint, class Head, class... Tail> mint multinomial(Head &&head, Tail &&... tail) { return fact<mint>(head) * fact_invs<mint>(std::forward<Tail>(tail)...); } template <typename mint> mint C_dense(int n, int k) { assert(n >= 0); if (k < 0 || n < k) return 0; static vvc<mint> C; static int H = 0, W = 0; auto calc = [&](int i, int j) -> mint { if (i == 0) return (j == 0 ? mint(1) : mint(0)); return C[i - 1][j] + (j ? C[i - 1][j - 1] : 0); }; if (W <= k) { FOR(i, H) { C[i].resize(k + 1); FOR(j, W, k + 1) { C[i][j] = calc(i, j); } } W = k + 1; } if (H <= n) { C.resize(n + 1); FOR(i, H, n + 1) { C[i].resize(W); FOR(j, W) { C[i][j] = calc(i, j); } } H = n + 1; } return C[n][k]; } template <typename mint, bool large = false, bool dense = false> mint C(ll n, ll k) { assert(n >= 0); if (k < 0 || n < k) return 0; if constexpr (dense) return C_dense<mint>(n, k); if constexpr (!large) return multinomial<mint>(n, k, n - k); k = min(k, n - k); mint x(1); FOR(i, k) x *= mint(n - i); return x * fact_inv<mint>(k); } template <typename mint, bool large = false> mint C_inv(ll n, ll k) { assert(n >= 0); assert(0 <= k && k <= n); if (!large) return fact_inv<mint>(n) * fact<mint>(k) * fact<mint>(n - k); return mint(1) / C<mint, 1>(n, k); } // [x^d](1-x)^{-n} template <typename mint, bool large = false, bool dense = false> mint C_negative(ll n, ll d) { assert(n >= 0); if (d < 0) return mint(0); if (n == 0) { return (d == 0 ? mint(1) : mint(0)); } return C<mint, large, dense>(n + d - 1, d); } #line 3 "mod/modint.hpp" template <int mod> struct modint { static constexpr u32 umod = u32(mod); static_assert(umod < u32(1) << 31); u32 val; static modint raw(u32 v) { modint x; x.val = v; return x; } constexpr modint() : val(0) {} constexpr modint(u32 x) : val(x % umod) {} constexpr modint(u64 x) : val(x % umod) {} constexpr modint(u128 x) : val(x % umod) {} constexpr modint(int x) : val((x %= mod) < 0 ? x + mod : x){}; constexpr modint(ll x) : val((x %= mod) < 0 ? x + mod : x){}; constexpr modint(i128 x) : val((x %= mod) < 0 ? x + mod : x){}; bool operator<(const modint &other) const { return val < other.val; } modint &operator+=(const modint &p) { if ((val += p.val) >= umod) val -= umod; return *this; } modint &operator-=(const modint &p) { if ((val += umod - p.val) >= umod) val -= umod; return *this; } modint &operator*=(const modint &p) { val = u64(val) * p.val % umod; return *this; } modint &operator/=(const modint &p) { *this *= p.inverse(); return *this; } modint operator-() const { return modint::raw(val ? mod - val : u32(0)); } modint operator+(const modint &p) const { return modint(*this) += p; } modint operator-(const modint &p) const { return modint(*this) -= p; } modint operator*(const modint &p) const { return modint(*this) *= p; } modint operator/(const modint &p) const { return modint(*this) /= p; } bool operator==(const modint &p) const { return val == p.val; } bool operator!=(const modint &p) const { return val != p.val; } modint inverse() const { int a = val, b = mod, u = 1, v = 0, t; while (b > 0) { t = a / b; swap(a -= t * b, b), swap(u -= t * v, v); } return modint(u); } modint pow(ll n) const { assert(n >= 0); modint ret(1), mul(val); while (n > 0) { if (n & 1) ret *= mul; mul *= mul; n >>= 1; } return ret; } static constexpr int get_mod() { return mod; } // (n, r), r は 1 の 2^n 乗根 static constexpr pair<int, int> ntt_info() { if (mod == 120586241) return {20, 74066978}; if (mod == 167772161) return {25, 17}; if (mod == 469762049) return {26, 30}; if (mod == 754974721) return {24, 362}; if (mod == 880803841) return {23, 211}; if (mod == 943718401) return {22, 663003469}; if (mod == 998244353) return {23, 31}; if (mod == 1004535809) return {21, 582313106}; if (mod == 1012924417) return {21, 368093570}; return {-1, -1}; } static constexpr bool can_ntt() { return ntt_info().fi != -1; } }; #ifdef FASTIO template <int mod> void rd(modint<mod> &x) { fastio::rd(x.val); x.val %= mod; // assert(0 <= x.val && x.val < mod); } template <int mod> void wt(modint<mod> x) { fastio::wt(x.val); } #endif using modint107 = modint<1000000007>; using modint998 = modint<998244353>; #line 3 "linalg/matrix_mul.hpp" template <class T, typename enable_if<has_mod<T>::value>::type* = nullptr> vc<vc<T>> matrix_mul(const vc<vc<T>>& A, const vc<vc<T>>& B, int N1 = -1, int N2 = -1, int N3 = -1) { if (N1 == -1) { N1 = len(A), N2 = len(B), N3 = len(B[0]); } vv(u32, b, N3, N2); FOR(i, N2) FOR(j, N3) b[j][i] = B[i][j].val; vv(T, C, N1, N3); if ((T::get_mod() < (1 << 30)) && N2 <= 16) { FOR(i, N1) FOR(j, N3) { u64 sm = 0; FOR(m, N2) sm += u64(A[i][m].val) * b[j][m]; C[i][j] = sm; } } else { FOR(i, N1) FOR(j, N3) { u128 sm = 0; FOR(m, N2) sm += u64(A[i][m].val) * b[j][m]; C[i][j] = T::raw(sm % (T::get_mod())); } } return C; } template <class T, typename enable_if<!has_mod<T>::value>::type* = nullptr> vc<vc<T>> matrix_mul(const vc<vc<T>>& A, const vc<vc<T>>& B, int N1 = -1, int N2 = -1, int N3 = -1) { if (N1 == -1) { N1 = len(A), N2 = len(B), N3 = len(B[0]); } vv(T, b, N2, N3); FOR(i, N2) FOR(j, N3) b[j][i] = B[i][j]; vv(T, C, N1, N3); FOR(n, N1) FOR(m, N2) FOR(k, N3) C[n][k] += A[n][m] * b[k][m]; return C; } // square-matrix defined as array template <class T, int N, typename enable_if<has_mod<T>::value>::type* = nullptr> array<array<T, N>, N> matrix_mul(const array<array<T, N>, N>& A, const array<array<T, N>, N>& B) { array<array<T, N>, N> C{}; if ((T::get_mod() < (1 << 30)) && N <= 16) { FOR(i, N) FOR(k, N) { u64 sm = 0; FOR(j, N) sm += u64(A[i][j].val) * (B[j][k].val); C[i][k] = sm; } } else { FOR(i, N) FOR(k, N) { u128 sm = 0; FOR(j, N) sm += u64(A[i][j].val) * (B[j][k].val); C[i][k] = sm; } } return C; } // square-matrix defined as array template <class T, int N, typename enable_if<!has_mod<T>::value>::type* = nullptr> array<array<T, N>, N> matrix_mul(const array<array<T, N>, N>& A, const array<array<T, N>, N>& B) { array<array<T, N>, N> C{}; FOR(i, N) FOR(j, N) FOR(k, N) C[i][k] += A[i][j] * B[j][k]; return C; } #line 2 "mod/mod_inv.hpp" // long でも大丈夫 // (val * x - 1) が mod の倍数になるようにする // 特に mod=0 なら x=0 が満たす ll mod_inv(ll val, ll mod) { if (mod == 0) return 0; mod = abs(mod); val %= mod; if (val < 0) val += mod; ll a = val, b = mod, u = 1, v = 0, t; while (b > 0) { t = a / b; swap(a -= t * b, b), swap(u -= t * v, v); } if (u < 0) u += mod; return u; } #line 2 "mod/crt3.hpp" constexpr u32 mod_pow_constexpr(u64 a, u64 n, u32 mod) { a %= mod; u64 res = 1; FOR(32) { if (n & 1) res = res * a % mod; a = a * a % mod, n /= 2; } return res; } template <typename T, u32 p0, u32 p1> T CRT2(u64 a0, u64 a1) { static_assert(p0 < p1); static constexpr u64 x0_1 = mod_pow_constexpr(p0, p1 - 2, p1); u64 c = (a1 - a0 + p1) * x0_1 % p1; return a0 + c * p0; } template <typename T, u32 p0, u32 p1, u32 p2> T CRT3(u64 a0, u64 a1, u64 a2) { static_assert(p0 < p1 && p1 < p2); static constexpr u64 x1 = mod_pow_constexpr(p0, p1 - 2, p1); static constexpr u64 x2 = mod_pow_constexpr(u64(p0) * p1 % p2, p2 - 2, p2); static constexpr u64 p01 = u64(p0) * p1; u64 c = (a1 - a0 + p1) * x1 % p1; u64 ans_1 = a0 + c * p0; c = (a2 - ans_1 % p2 + p2) * x2 % p2; return T(ans_1) + T(c) * T(p01); } template <typename T, u32 p0, u32 p1, u32 p2, u32 p3> T CRT4(u64 a0, u64 a1, u64 a2, u64 a3) { static_assert(p0 < p1 && p1 < p2 && p2 < p3); static constexpr u64 x1 = mod_pow_constexpr(p0, p1 - 2, p1); static constexpr u64 x2 = mod_pow_constexpr(u64(p0) * p1 % p2, p2 - 2, p2); static constexpr u64 x3 = mod_pow_constexpr(u64(p0) * p1 % p3 * p2 % p3, p3 - 2, p3); static constexpr u64 p01 = u64(p0) * p1; u64 c = (a1 - a0 + p1) * x1 % p1; u64 ans_1 = a0 + c * p0; c = (a2 - ans_1 % p2 + p2) * x2 % p2; u128 ans_2 = ans_1 + c * static_cast<u128>(p01); c = (a3 - ans_2 % p3 + p3) * x3 % p3; return T(ans_2) + T(c) * T(p01) * T(p2); } template <typename T, u32 p0, u32 p1, u32 p2, u32 p3, u32 p4> T CRT5(u64 a0, u64 a1, u64 a2, u64 a3, u64 a4) { static_assert(p0 < p1 && p1 < p2 && p2 < p3 && p3 < p4); static constexpr u64 x1 = mod_pow_constexpr(p0, p1 - 2, p1); static constexpr u64 x2 = mod_pow_constexpr(u64(p0) * p1 % p2, p2 - 2, p2); static constexpr u64 x3 = mod_pow_constexpr(u64(p0) * p1 % p3 * p2 % p3, p3 - 2, p3); static constexpr u64 x4 = mod_pow_constexpr(u64(p0) * p1 % p4 * p2 % p4 * p3 % p4, p4 - 2, p4); static constexpr u64 p01 = u64(p0) * p1; static constexpr u64 p23 = u64(p2) * p3; u64 c = (a1 - a0 + p1) * x1 % p1; u64 ans_1 = a0 + c * p0; c = (a2 - ans_1 % p2 + p2) * x2 % p2; u128 ans_2 = ans_1 + c * static_cast<u128>(p01); c = static_cast<u64>(a3 - ans_2 % p3 + p3) * x3 % p3; u128 ans_3 = ans_2 + static_cast<u128>(c * p2) * p01; c = static_cast<u64>(a4 - ans_3 % p4 + p4) * x4 % p4; return T(ans_3) + T(c) * T(p01) * T(p23); } #line 2 "poly/convolution_naive.hpp" template <class T, typename enable_if<!has_mod<T>::value>::type* = nullptr> vc<T> convolution_naive(const vc<T>& a, const vc<T>& b) { int n = int(a.size()), m = int(b.size()); if (n > m) return convolution_naive<T>(b, a); if (n == 0) return {}; vector<T> ans(n + m - 1); FOR(i, n) FOR(j, m) ans[i + j] += a[i] * b[j]; return ans; } template <class T, typename enable_if<has_mod<T>::value>::type* = nullptr> vc<T> convolution_naive(const vc<T>& a, const vc<T>& b) { int n = int(a.size()), m = int(b.size()); if (n > m) return convolution_naive<T>(b, a); if (n == 0) return {}; vc<T> ans(n + m - 1); if (n <= 16 && (T::get_mod() < (1 << 30))) { for (int k = 0; k < n + m - 1; ++k) { int s = max(0, k - m + 1); int t = min(n, k + 1); u64 sm = 0; for (int i = s; i < t; ++i) { sm += u64(a[i].val) * (b[k - i].val); } ans[k] = sm; } } else { for (int k = 0; k < n + m - 1; ++k) { int s = max(0, k - m + 1); int t = min(n, k + 1); u128 sm = 0; for (int i = s; i < t; ++i) { sm += u64(a[i].val) * (b[k - i].val); } ans[k] = T::raw(sm % T::get_mod()); } } return ans; } #line 2 "poly/convolution_karatsuba.hpp" // 任意の環でできる template <typename T> vc<T> convolution_karatsuba(const vc<T>& f, const vc<T>& g) { const int thresh = 30; if (min(len(f), len(g)) <= thresh) return convolution_naive(f, g); int n = max(len(f), len(g)); int m = ceil(n, 2); vc<T> f1, f2, g1, g2; if (len(f) < m) f1 = f; if (len(f) >= m) f1 = {f.begin(), f.begin() + m}; if (len(f) >= m) f2 = {f.begin() + m, f.end()}; if (len(g) < m) g1 = g; if (len(g) >= m) g1 = {g.begin(), g.begin() + m}; if (len(g) >= m) g2 = {g.begin() + m, g.end()}; vc<T> a = convolution_karatsuba(f1, g1); vc<T> b = convolution_karatsuba(f2, g2); FOR(i, len(f2)) f1[i] += f2[i]; FOR(i, len(g2)) g1[i] += g2[i]; vc<T> c = convolution_karatsuba(f1, g1); vc<T> F(len(f) + len(g) - 1); assert(2 * m + len(b) <= len(F)); FOR(i, len(a)) F[i] += a[i], c[i] -= a[i]; FOR(i, len(b)) F[2 * m + i] += b[i], c[i] -= b[i]; if (c.back() == T(0)) c.pop_back(); FOR(i, len(c)) if (c[i] != T(0)) F[m + i] += c[i]; return F; } #line 2 "poly/ntt.hpp" template <class mint> void ntt(vector<mint>& a, bool inverse) { assert(mint::can_ntt()); const int rank2 = mint::ntt_info().fi; const int mod = mint::get_mod(); static array<mint, 30> root, iroot; static array<mint, 30> rate2, irate2; static array<mint, 30> rate3, irate3; assert(rank2 != -1 && len(a) <= (1 << max(0, rank2))); static bool prepared = 0; if (!prepared) { prepared = 1; root[rank2] = mint::ntt_info().se; iroot[rank2] = mint(1) / root[rank2]; FOR_R(i, rank2) { root[i] = root[i + 1] * root[i + 1]; iroot[i] = iroot[i + 1] * iroot[i + 1]; } mint prod = 1, iprod = 1; for (int i = 0; i <= rank2 - 2; i++) { rate2[i] = root[i + 2] * prod; irate2[i] = iroot[i + 2] * iprod; prod *= iroot[i + 2]; iprod *= root[i + 2]; } prod = 1, iprod = 1; for (int i = 0; i <= rank2 - 3; i++) { rate3[i] = root[i + 3] * prod; irate3[i] = iroot[i + 3] * iprod; prod *= iroot[i + 3]; iprod *= root[i + 3]; } } int n = int(a.size()); int h = topbit(n); assert(n == 1 << h); if (!inverse) { int len = 0; while (len < h) { if (h - len == 1) { int p = 1 << (h - len - 1); mint rot = 1; FOR(s, 1 << len) { int offset = s << (h - len); FOR(i, p) { auto l = a[i + offset]; auto r = a[i + offset + p] * rot; a[i + offset] = l + r; a[i + offset + p] = l - r; } rot *= rate2[topbit(~s & -~s)]; } len++; } else { int p = 1 << (h - len - 2); mint rot = 1, imag = root[2]; for (int s = 0; s < (1 << len); s++) { mint rot2 = rot * rot; mint rot3 = rot2 * rot; int offset = s << (h - len); for (int i = 0; i < p; i++) { u64 mod2 = u64(mod) * mod; u64 a0 = a[i + offset].val; u64 a1 = u64(a[i + offset + p].val) * rot.val; u64 a2 = u64(a[i + offset + 2 * p].val) * rot2.val; u64 a3 = u64(a[i + offset + 3 * p].val) * rot3.val; u64 a1na3imag = (a1 + mod2 - a3) % mod * imag.val; u64 na2 = mod2 - a2; a[i + offset] = a0 + a2 + a1 + a3; a[i + offset + 1 * p] = a0 + a2 + (2 * mod2 - (a1 + a3)); a[i + offset + 2 * p] = a0 + na2 + a1na3imag; a[i + offset + 3 * p] = a0 + na2 + (mod2 - a1na3imag); } rot *= rate3[topbit(~s & -~s)]; } len += 2; } } } else { mint coef = mint(1) / mint(len(a)); FOR(i, len(a)) a[i] *= coef; int len = h; while (len) { if (len == 1) { int p = 1 << (h - len); mint irot = 1; FOR(s, 1 << (len - 1)) { int offset = s << (h - len + 1); FOR(i, p) { u64 l = a[i + offset].val; u64 r = a[i + offset + p].val; a[i + offset] = l + r; a[i + offset + p] = (mod + l - r) * irot.val; } irot *= irate2[topbit(~s & -~s)]; } len--; } else { int p = 1 << (h - len); mint irot = 1, iimag = iroot[2]; FOR(s, (1 << (len - 2))) { mint irot2 = irot * irot; mint irot3 = irot2 * irot; int offset = s << (h - len + 2); for (int i = 0; i < p; i++) { u64 a0 = a[i + offset + 0 * p].val; u64 a1 = a[i + offset + 1 * p].val; u64 a2 = a[i + offset + 2 * p].val; u64 a3 = a[i + offset + 3 * p].val; u64 x = (mod + a2 - a3) * iimag.val % mod; a[i + offset] = a0 + a1 + a2 + a3; a[i + offset + 1 * p] = (a0 + mod - a1 + x) * irot.val; a[i + offset + 2 * p] = (a0 + a1 + 2 * mod - a2 - a3) * irot2.val; a[i + offset + 3 * p] = (a0 + 2 * mod - a1 - x) * irot3.val; } irot *= irate3[topbit(~s & -~s)]; } len -= 2; } } } } #line 8 "poly/convolution.hpp" template <class mint> vector<mint> convolution_ntt(vector<mint> a, vector<mint> b) { if (a.empty() || b.empty()) return {}; int n = int(a.size()), m = int(b.size()); int sz = 1; while (sz < n + m - 1) sz *= 2; // sz = 2^k のときの高速化。分割統治的なやつで損しまくるので。 if ((n + m - 3) <= sz / 2) { auto a_last = a.back(), b_last = b.back(); a.pop_back(), b.pop_back(); auto c = convolution(a, b); c.resize(n + m - 1); c[n + m - 2] = a_last * b_last; FOR(i, len(a)) c[i + len(b)] += a[i] * b_last; FOR(i, len(b)) c[i + len(a)] += b[i] * a_last; return c; } a.resize(sz), b.resize(sz); bool same = a == b; ntt(a, 0); if (same) { b = a; } else { ntt(b, 0); } FOR(i, sz) a[i] *= b[i]; ntt(a, 1); a.resize(n + m - 1); return a; } template <typename mint> vector<mint> convolution_garner(const vector<mint>& a, const vector<mint>& b) { int n = len(a), m = len(b); if (!n || !m) return {}; static constexpr int p0 = 167772161; static constexpr int p1 = 469762049; static constexpr int p2 = 754974721; using mint0 = modint<p0>; using mint1 = modint<p1>; using mint2 = modint<p2>; vc<mint0> a0(n), b0(m); vc<mint1> a1(n), b1(m); vc<mint2> a2(n), b2(m); FOR(i, n) a0[i] = a[i].val, a1[i] = a[i].val, a2[i] = a[i].val; FOR(i, m) b0[i] = b[i].val, b1[i] = b[i].val, b2[i] = b[i].val; auto c0 = convolution_ntt<mint0>(a0, b0); auto c1 = convolution_ntt<mint1>(a1, b1); auto c2 = convolution_ntt<mint2>(a2, b2); vc<mint> c(len(c0)); FOR(i, n + m - 1) { c[i] = CRT3<mint, p0, p1, p2>(c0[i].val, c1[i].val, c2[i].val); } return c; } vector<ll> convolution(vector<ll> a, vector<ll> b) { int n = len(a), m = len(b); if (!n || !m) return {}; if (min(n, m) <= 2500) return convolution_naive(a, b); ll mi_a = MIN(a), mi_b = MIN(b); for (auto& x: a) x -= mi_a; for (auto& x: b) x -= mi_b; assert(MAX(a) * MAX(b) <= 1e18); auto Ac = cumsum<ll>(a), Bc = cumsum<ll>(b); vi res(n + m - 1); for (int k = 0; k < n + m - 1; ++k) { int s = max(0, k - m + 1); int t = min(n, k + 1); res[k] += (t - s) * mi_a * mi_b; res[k] += mi_a * (Bc[k - s + 1] - Bc[k - t + 1]); res[k] += mi_b * (Ac[t] - Ac[s]); } static constexpr u32 MOD1 = 1004535809; static constexpr u32 MOD2 = 1012924417; using mint1 = modint<MOD1>; using mint2 = modint<MOD2>; vc<mint1> a1(n), b1(m); vc<mint2> a2(n), b2(m); FOR(i, n) a1[i] = a[i], a2[i] = a[i]; FOR(i, m) b1[i] = b[i], b2[i] = b[i]; auto c1 = convolution_ntt<mint1>(a1, b1); auto c2 = convolution_ntt<mint2>(a2, b2); FOR(i, n + m - 1) { res[i] += CRT2<u64, MOD1, MOD2>(c1[i].val, c2[i].val); } return res; } template <typename mint> vc<mint> convolution(const vc<mint>& a, const vc<mint>& b) { int n = len(a), m = len(b); if (!n || !m) return {}; if (mint::can_ntt()) { if (min(n, m) <= 50) return convolution_karatsuba<mint>(a, b); return convolution_ntt(a, b); } if (min(n, m) <= 200) return convolution_karatsuba<mint>(a, b); return convolution_garner(a, b); } #line 2 "linalg/basis.hpp" // basis[i]: i 番目に追加成功したもの. 別のラベルがあるなら外で管理する. // rbasis: 上三角化された基底. [i][i]==1. // way[i][j]: rbasis[i] = sum way[i][j] basis[j] template <typename mint> struct Basis { int n, rank; vvc<mint> basis; vvc<mint> rbasis; vvc<mint> way; Basis(int max_dim) : n(max_dim), rank(0), basis{} { rbasis.assign(max_dim, vc<mint>(max_dim)); way.assign(max_dim, vc<mint>(max_dim)); } // return : (sum==X にできるか, その方法) pair<bool, vc<mint>> solve(vc<mint> X) { vc<mint> CF(n); FOR(i, n) { if (rbasis[i][i] == mint(1)) { CF[i] = X[i]; FOR(j, i, n) X[j] -= CF[i] * rbasis[i][j]; } } for (auto& x: X) { if (x != mint(0)) { return {false, {}}; } } vc<mint> ANS(rank); FOR(i, n) { FOR(j, rank) ANS[j] += CF[i] * way[i][j]; } return {true, ANS}; } // return : (sum==x にできるか, その方法). false の場合には追加する pair<bool, vc<mint>> solve_or_add(vc<mint> X) { vc<mint> Y = X; vc<mint> CF(n); FOR(i, n) { if (rbasis[i][i] == mint(1)) { CF[i] = X[i]; FOR(j, i, n) X[j] -= CF[i] * rbasis[i][j]; } } int p = [&]() -> int { FOR(i, n) if (X[i] != mint(0)) return i; return -1; }(); if (p == -1) { vc<mint> ANS(rank); FOR(i, n) { FOR(j, rank) ANS[j] += CF[i] * way[i][j]; } return {true, ANS}; } mint c = X[p].inverse(); FOR(j, p, n) X[j] *= c; FOR(i, n) CF[i] *= c; basis.eb(Y), rbasis[p] = X; way[p][rank] = c; FOR(i, n) { FOR(j, rank) way[p][j] -= CF[i] * way[i][j]; } ++rank; return {false, {}}; } // rank==r の時点まで戻す. Frobenius Form 用. void rollback(int r) { while (rank > r) { --rank; POP(basis); FOR(i, n) if (way[i][rank] != mint(0)) { fill(all(rbasis[i]), mint(0)); fill(all(way[i]), mint(0)); } } } }; #line 2 "poly/convolution_all.hpp" #line 2 "poly/ntt_doubling.hpp" #line 4 "poly/ntt_doubling.hpp" // 2^k 次多項式の長さ 2^k が与えられるので 2^k+1 にする template <typename mint, bool transposed = false> void ntt_doubling(vector<mint>& a) { static array<mint, 30> root; static bool prepared = 0; if (!prepared) { prepared = 1; const int rank2 = mint::ntt_info().fi; root[rank2] = mint::ntt_info().se; FOR_R(i, rank2) { root[i] = root[i + 1] * root[i + 1]; } } if constexpr (!transposed) { const int M = (int)a.size(); auto b = a; ntt(b, 1); mint r = 1, zeta = root[topbit(2 * M)]; FOR(i, M) b[i] *= r, r *= zeta; ntt(b, 0); copy(begin(b), end(b), back_inserter(a)); } else { const int M = len(a) / 2; vc<mint> tmp = {a.begin(), a.begin() + M}; a = {a.begin() + M, a.end()}; transposed_ntt(a, 0); mint r = 1, zeta = root[topbit(2 * M)]; FOR(i, M) a[i] *= r, r *= zeta; transposed_ntt(a, 1); FOR(i, M) a[i] += tmp[i]; } } #line 5 "poly/convolution_all.hpp" template <typename T> vc<T> convolution_all(vc<vc<T>>& polys) { if (len(polys) == 0) return {T(1)}; while (1) { int n = len(polys); if (n == 1) break; int m = ceil(n, 2); FOR(i, m) { if (2 * i + 1 == n) { polys[i] = polys[2 * i]; } else { polys[i] = convolution(polys[2 * i], polys[2 * i + 1]); } } polys.resize(m); } return polys[0]; } // product of 1-A[i]x template <typename mint> vc<mint> convolution_all_1(vc<mint> A) { if (!mint::can_ntt()) { vvc<mint> polys; for (auto& a: A) polys.eb(vc<mint>({mint(1), -a})); return convolution_all(polys); } int D = 6; using poly = vc<mint>; int n = 1; while (n < len(A)) n *= 2; int k = topbit(n); vc<mint> F(n), nxt_F(n); FOR(i, len(A)) F[i] = -A[i]; FOR(d, k) { int b = 1 << d; if (d < D) { fill(all(nxt_F), mint(0)); for (int L = 0; L < n; L += 2 * b) { FOR(i, b) FOR(j, b) { nxt_F[L + i + j] += F[L + i] * F[L + b + j]; } FOR(i, b) nxt_F[L + b + i] += F[L + i] + F[L + b + i]; } } elif (d == D) { for (int L = 0; L < n; L += 2 * b) { poly f1 = {F.begin() + L, F.begin() + L + b}; poly f2 = {F.begin() + L + b, F.begin() + L + 2 * b}; f1.resize(2 * b), f2.resize(2 * b), ntt(f1, 0), ntt(f2, 0); FOR(i, b) nxt_F[L + i] = f1[i] * f2[i] + f1[i] + f2[i]; FOR(i, b, 2 * b) nxt_F[L + i] = f1[i] * f2[i] - f1[i] - f2[i]; } } else { for (int L = 0; L < n; L += 2 * b) { poly f1 = {F.begin() + L, F.begin() + L + b}; poly f2 = {F.begin() + L + b, F.begin() + L + 2 * b}; ntt_doubling(f1), ntt_doubling(f2); FOR(i, b) nxt_F[L + i] = f1[i] * f2[i] + f1[i] + f2[i]; FOR(i, b, 2 * b) nxt_F[L + i] = f1[i] * f2[i] - f1[i] - f2[i]; } } swap(F, nxt_F); } if (k - 1 >= D) ntt(F, 1); F.eb(1), reverse(all(F)); F.resize(len(A) + 1); return F; } #line 8 "linalg/frobenius.hpp" // https://codeforces.com/blog/entry/124815 // P^{-1}AP = diag(companion(f0),companion(f1),...) // without checking: ...|f2|f1|f0. // time complexity O(N^3). failure prob O(N/mod). template <typename mint> struct Frobenius_Form { int n; // b : num of blocks const vvc<mint> A; vvc<mint> P, IP; vvc<mint> V; vvc<mint> F; // [-a0,-a1,...,-a[k-1]] の形で管理 (x^k と合同なもの) Frobenius_Form(vvc<mint>& A) : n(len(A)), A(A) { while (!trial()) {} } // N^3 + N^2log(exp) vvc<mint> pow(ll exp) { vv(mint, X, n, n); int s = 0; FOR(k, len(F)) { int d = len(F[k]); vc<mint> f = powmod(F[k], exp); FOR(j, d) { FOR(i, len(f)) { X[s + i][s + j] = f[i]; } if (j == d - 1) break; f.insert(f.begin(), 0); divmod_inplace(f, F[k]); } s += d; } X = matrix_mul(P, X); X = matrix_mul(X, IP); return X; } // p(A) vvc<mint> poly_eval(vc<mint>& p) { vv(mint, X, n, n); int s = 0; FOR(k, len(F)) { int d = len(F[k]); vc<mint> f = p; divmod_inplace(f, F[k]); FOR(j, d) { FOR(i, len(f)) { X[s + i][s + j] = f[i]; } if (j == d - 1) break; f.insert(f.begin(), 0); divmod_inplace(f, F[k]); } s += d; } X = matrix_mul(P, X); X = matrix_mul(X, IP); return X; } vc<mint> characteristic_poly() { vvc<mint> polys; for (auto& f: F) { vc<mint> g = f; for (auto& x: g) x = -x; g.eb(1); polys.eb(g); } vc<mint> f = convolution_all(polys); return f; } private: bool trial() { V.clear(), F.clear(); Basis<mint> S(n); while (1) { if (S.rank == n) break; int r = S.rank; vc<mint> v = random_vector(); V.eb(v); while (1) { auto [solved, cf] = S.solve_or_add(v); if (!solved) { v = apply(v); continue; } vc<mint> f = {cf.begin() + r, cf.end()}; F.eb(f); if (len(V) == 1) break; v = V.back(); int s = 0; FOR(k, len(V) - 1) { int d = len(F[k]); vc<mint> R = {cf.begin() + s, cf.begin() + s + d}; vc<mint> q = divmod_inplace(R, f); if (!R.empty()) { return false; // failure } FOR(i, len(q)) { FOR(j, n) v[j] -= q[i] * S.basis[s + i][j]; } s += d; } S.rollback(r); V.back() = v; FOR(i, len(f)) { S.solve_or_add(v); if (i + 1 < len(f)) v = apply(v); } break; } } P.assign(n, vc<mint>(n)); FOR(i, n) FOR(j, n) P[i][j] = S.basis[j][i]; IP = matrix_inv<mint>(P).se; return true; } vc<mint> random_vector() { vc<mint> v(n); FOR(i, n) v[i] = RNG(0, mint::get_mod()); return v; } vc<mint> apply(vc<mint> v) { vc<mint> w(n); FOR(i, n) FOR(j, n) w[i] += A[i][j] * v[j]; return w; } // f mod= (x^d-g(x)) (inplace), return : q vc<mint> divmod_inplace(vc<mint>& f, vc<mint>& g) { while (len(f) && f.back() == mint(0)) POP(f); int d = len(g); vc<mint> q; FOR_R(i, d, len(f)) { q.eb(f[i]); FOR(j, len(g)) f[i - d + j] += f[i] * g[j]; f[i] = 0; } while (len(f) && f.back() == mint(0)) POP(f); reverse(all(q)); return q; } // x^n mod (x^d-g(x)) vc<mint> powmod(vc<mint>& g, ll n) { if (n < len(g)) { vc<mint> f(n + 1); f[n] = 1; return f; } vc<mint> f = powmod(g, n / 2); f = convolution_naive(f, f); if (n & 1) f.insert(f.begin(), 0); divmod_inplace(f, g); return f; } }; #line 1 "linalg/characteristic_poly.hpp" template <typename T> void to_Hessenberg_matrix(vc<vc<T>>& A) { /* P^{-1}AP の形の変換で、Hessenberg 行列に変形する。 特定多項式の計算に用いることができる。 */ int n = len(A); FOR(k, n - 2) { FOR3(i, k + 1, n) if (A[i][k] != 0) { if (i != k + 1) { swap(A[i], A[k + 1]); FOR(j, n) swap(A[j][i], A[j][k + 1]); } break; } if (A[k + 1][k] == 0) continue; FOR3(i, k + 2, n) { T c = A[i][k] / A[k + 1][k]; // i 行目 -= k+1 行目 * c FOR(j, n) A[i][j] -= A[k + 1][j] * c; // k+1 列目 += i 列目 * c FOR(j, n) A[j][k + 1] += A[j][i] * c; } } } // det(xI-A) template <typename T> vc<T> characteristic_poly(vc<vc<T>> A) { /* ・Hessenberg 行列に変形 ・Hessenberg 行列の行列式は、最後の列で場合分けすれば dp できる */ int n = len(A); to_Hessenberg_matrix(A); vc<vc<T>> DP(n + 1); DP[0] = {1}; FOR(k, n) { DP[k + 1].resize(k + 2); auto& dp = DP[k + 1]; // (k, k) 成分を使う場合 FOR(i, len(DP[k])) dp[i + 1] += DP[k][i]; FOR(i, len(DP[k])) dp[i] -= DP[k][i] * A[k][k]; // 下側対角の総積を管理 T prod = 1; FOR_R(i, k) { // (i, k) 成分を使う場合 prod *= A[i + 1][i]; T c = prod * A[i][k]; // DP[i] の c 倍を加算 FOR(j, len(DP[i])) dp[j] -= DP[i][j] * c; } } return DP[n]; } #line 6 "linalg/adjugate_matrix.hpp" template <typename mint> vvc<mint> adjugate_matrix(vvc<mint> A) { int N = len(A); Frobenius_Form<mint> X(A); auto F = X.characteristic_poly(); if (N % 2 == 0) { for (auto& x: F) x = -x; } F.erase(F.begin()); return X.poly_eval(F); }